package com.factory.wx.mapper;

import com.factory.web.entity.pm.res.AbnormalTaskInfoRes;
import com.factory.wx.entity.req.AbnormalPlanReq;
import com.factory.wx.entity.res.AbnormalPlanRes;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * @author sMArT
 * @version 1.0
 * @date 2021-07-23 2:09 上午
 */
@Mapper
public interface AbnormalStatisticsMapper {
    /**
     * 获取放行异常计划
     *
     * @return
     */
    List<AbnormalPlanRes> getReleasedAbnormalPlans(AbnormalPlanReq abnormalPlanReq);

    /**
     * 获取重检异常计划
     *
     * @param abnormalPlanReq
     * @return
     */
    List<AbnormalPlanRes> getRecheckedAbnormalPlans(AbnormalPlanReq abnormalPlanReq);

    /**
     * 根据计划id获取首件放行
     *
     * @param planId
     * @return
     */
    List<AbnormalTaskInfoRes> getFaReleaseListByPlanId(Long planId);

    /**
     * 根据计划id获取防错放行
     *
     * @param planId
     * @return
     */
    List<AbnormalTaskInfoRes> getPmReleaseListByPlanId(Long planId);
}
