package com.factory.wx.service.impl;

import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.wx.entity.req.PlanApprovalTaskReq;
import com.factory.wx.entity.req.PlanPageReq;
import com.factory.wx.entity.res.PlanPassRes;
import com.factory.wx.mapper.PlanPassMapper;
import com.factory.wx.service.PlanPassFAService;
import com.factory.wx.service.PlanPassPMService;
import com.factory.wx.service.PlanPassService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author sMArT
 * @version 1.0
 * @date 2021-07-13 12:42 下午
 */
@Service("planPassService")
public class PlanPassServiceImpl implements PlanPassService {

    private final static Logger LOGGER = LoggerFactory.getLogger(PlanPassServiceImpl.class);
    @Autowired
    private PlanPassMapper planPassMapper;
    @Autowired
    private PlanPassFAService planPassFAService;
    @Autowired
    private PlanPassPMService planPassPMService;

    /**
     * 计划放行列表
     *
     * @param planPageReq
     * @return
     */
    @Override
    public List<PlanPassRes> getPassList(PlanPageReq planPageReq) {
        //分页
        planPageReq.setPage((planPageReq.getPage() - 1) * planPageReq.getSize());
        List<PlanPassRes> planPassResList = new ArrayList<>();
        //首件列表
        if (planPageReq.getCheckType() == 1) {
            planPassResList = planPassMapper.getPlanPassList(planPageReq);
        }
        //防错列表
        if (planPageReq.getCheckType() == 2) {
            planPassResList = planPassMapper.getPlanPassPMList(planPageReq);
        }
        return planPassResList;
    }

    /**
     * 计划放行
     *
     * @param planApprovalTaskReq
     * @return
     */
    @Override
    public ResponseBean approvalTaskOperate(PlanApprovalTaskReq planApprovalTaskReq) {
        ResponseBean responseBean = new ResponseBean();
        if (planApprovalTaskReq.getPlanType() == 1) {
            responseBean = planPassFAService.approvalFATaskOperate(planApprovalTaskReq);
        }
        if (planApprovalTaskReq.getPlanType() == 2) {
            responseBean = planPassPMService.approvalPMTaskOperate(planApprovalTaskReq);
        }
        return responseBean;
    }

}
