package com.factory.wx.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.factory.base.entity.aggregates.ResponseBean;
import com.factory.base.util.res.ResponseBeanBuilder;
import com.factory.wx.entity.UsUserWechat;
import com.factory.wx.entity.res.FunctionsRes;
import com.factory.wx.mapper.WxMapper;
import com.factory.wx.service.WxService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author sMArT
 * @version 1.0
 * @date 2021-07-12 4:08 下午
 */
@Service("wxService")
@Transactional(rollbackFor = Exception.class)
public class WxServiceImpl implements WxService {

    @Autowired
    private WxMapper wxMapper;

    @Override
    public ResponseBean<List<FunctionsRes>> getUserFunction(Long userId) {
        List<FunctionsRes> functionList = wxMapper.getUserFunctions(userId);

//        List<FunctionsRes> functionsResList = new ArrayList<>();
//        functionList.forEach((i) -> {
//            FunctionsRes functionsRes = new FunctionsRes();
//            functionsRes.setFunction(i.getFunction());
//            functionsRes.setName(i.getName());
//            functionsResList.add(functionsRes);
//        });

        return ResponseBeanBuilder.ok(functionList);
    }

    @Override
    public ResponseBean bindWeChatUser(String openId, Long userId) {
        UsUserWechat usUserWechat = wxMapper.selectOne(Wrappers.<UsUserWechat>lambdaQuery()
                .eq(UsUserWechat::getUserId, userId));
        if (null != usUserWechat) {
            UsUserWechat user = new UsUserWechat();
            user.setId(usUserWechat.getId());
            user.setOpenid(openId);
            Integer rows = wxMapper.updateById(user);
//            if (rows == 0) return ResponseBeanBuilder.fail("更新绑定信息失败");
        } else {
            UsUserWechat user = new UsUserWechat();
            user.setUserId(userId);
            user.setOpenid(openId);
            wxMapper.insert(user);
        }
        return ResponseBeanBuilder.ok();
    }

    @Override
    public Integer selectBindWeChatUserCount(String openid, Long userId) {
        return wxMapper.selectCount(Wrappers.<UsUserWechat>lambdaQuery().eq(UsUserWechat::getUserId, userId).eq(UsUserWechat::getOpenid, openid));
    }
}
